"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSplunkEventsStream = void 0;

var _split = _interopRequireDefault(require("split2"));

var _pumpify = _interopRequireDefault(require("pumpify"));

var _through = _interopRequireDefault(require("through2"));

var _toSplunkEvent = require("./toSplunkEvent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createSplunkEventsStream = splunk => {
  const logChunk = chunk => {
    if ((0, _toSplunkEvent.isSplunkLog)(chunk)) {
      const event = (0, _toSplunkEvent.toSplunkEvent)(chunk);
      splunk.logEvent(event.severity.level, event.severity.type, event.workflow.type, event.workflow.instance, event.data, event.account);
    } else {
      splunk.logEvent('Important', 'Warn', 'fallback-log', 'invalid-pino-log', {
        msg: chunk
      });
    }
  };

  const writeStream = new _pumpify.default((0, _split.default)(line => {
    try {
      return JSON.parse(line);
    } catch (e) {
      return undefined;
    }
  }), _through.default.obj((chunk, _enc, next) => {
    logChunk(chunk);
    next();
  }));
  writeStream.on('error', error => {
    console.error('[pino-splunk-events] Write stream error:', error);
  });
  return writeStream;
};

exports.createSplunkEventsStream = createSplunkEventsStream;
//# sourceMappingURL=createSplunkEventsStream.js.map